#!/usr/bin/perl -w

package Dialog;

BEGIN {
    use src::MymoneyUI;
};


use strict;

#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;


use lib "./";

my $MyUI;
my $retval=0;

sub show {
    my ($class, %params) = @_;
    
    my $window=$class;
    $MyUI=$window;
    $retval=0;
    if(defined($params{'text'})) {
        $window->FORM->{'label_dialog'}->set_label($params{'text'});
    };
    $window->FORM->{'button_ok'}->hide;
    $window->FORM->{'button_close1'}->hide;
    $window->FORM->{'button_close'}->show;
    if(defined($params{'type'})) {
        if($params{'type'} eq "info") {
            $window->FORM->{'image_dialog'}->set_from_stock('gtk-dialog-info','dialog');
            $window->TOPLEVEL->set_title("Informace");
        };
        if($params{'type'} eq "warning") {
            $window->FORM->{'image_dialog'}->set_from_stock('gtk-dialog-warning','dialog');
            $window->TOPLEVEL->set_title("Varování");
        };
        if($params{'type'} eq "error") {
            $window->FORM->{'image_dialog'}->set_from_stock('gtk-dialog-error','dialog');
            $window->TOPLEVEL->set_title("Chyba");
        };
        if($params{'type'} eq "question") {
            $window->FORM->{'image_dialog'}->set_from_stock('gtk-dialog-question','dialog');
            $window->TOPLEVEL->set_title("Otázka");
            $window->FORM->{'button_ok'}->show;
            $window->FORM->{'button_close1'}->show;
            $window->FORM->{'button_close'}->hide;
        };
        if(!$params{'type'}) {
            $window->FORM->{'image_dialog'}->hide;
        };
    } else {
        $window->FORM->{'image_dialog'}->hide;
    };
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retval);
};

sub on_button_ok_clicked {
    my $window=$MyUI;
    $retval=1;
    $window->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_button_close_clicked {
    my $window=$MyUI;
    $retval=0;
    $window->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_Dialog_unrealize {
    $retval=0;
    Gtk2->main_quit;
};


1;
