#!/usr/bin/perl -w

package KartaPolozkyFaktury;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";

my $MyUI;
my %MyMoney;
my @Polozky;
my $retok;
my $polozka;
my $copy;
my $KartaPolozkyFaktury;
my @SazbyDPH=(0);
my $changes_dissabled=0;


my $ZAKLAD=0;
my $DPH=0;
my $MJVCDPH=0;
my $CELKEMZAKLAD=0;
my $CELKEMDPH=0;
my $CELKEMVCDPH=0;


sub run {
    my ($class,%params) = @_;
    $retok=0;

    my $window=$class;
    $MyUI=$class;
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'vbox215'};
    
    %MyMoney=@{$params{'cfg'}};
    @Polozky=@{$params{'polozky'}};
    $polozka=$params{'polozka'};
    $copy=$params{'copy'};
    push(@SazbyDPH,$params{'sazbadph1'},$params{'sazbadph2'});
    
    my $menuitem=new_with_mnemonic Gtk2::MenuItem($SazbyDPH[1]." %");
    $MyUI->FORM->{'menu70'}->append($menuitem);
    $menuitem->show;
    $menuitem=new_with_mnemonic Gtk2::MenuItem($SazbyDPH[2]." %");
    $MyUI->FORM->{'menu70'}->append($menuitem);
    $menuitem->show;
    
    my $pocetpolozek=@Polozky;
    
    if((!$polozka) && (!$copy)) {
        #nova polozka
        $pocetpolozek++;
        $KartaPolozkyFaktury=new Table('r_VFaktPol',%MyMoney);
        $KartaPolozkyFaktury->set('poradi',$pocetpolozek);
        if($MyMoney{'MainCfg'}->get('VFPol_last_typceny')) {
            $KartaPolozkyFaktury->set('typceny',$MyMoney{'MainCfg'}->get('VFPol_last_typceny'));
        };
        if($MyMoney{'MainCfg'}->get('VFPol_last_sazbadph')) {
            $KartaPolozkyFaktury->set('sazbadph',$MyMoney{'MainCfg'}->get('VFPol_last_sazbadph'));
        };
        if(($pocetpolozek==1) && (defined($params{'popis'}))) {
            $KartaPolozkyFaktury->set('popis',$params{'popis'});
        };
    } else {
        if(!$copy) {
            $KartaPolozkyFaktury=$Polozky[$polozka-1];
        } else {
            $KartaPolozkyFaktury=new Table('r_VFaktPol',%MyMoney);
            $KartaPolozkyFaktury->set_data($Polozky[$params{'copy'}-1]->get_data);
            $KartaPolozkyFaktury->set('id',0);
            $pocetpolozek++;
            $KartaPolozkyFaktury->set('poradi',$pocetpolozek);
        };
    };
    $MyUI->FORM->{'poradi'}->set_range(1,$pocetpolozek);
    
    $changes_dissabled=1;
    $KartaPolozkyFaktury->WriteToUI($MyUI->FORM);
    $changes_dissabled=0;
    $MyUI->on_cenamj_changed;
    $MyUI->on_zaruka_changed;
    $MyUI->on_typceny_changed;
    
    $window->TOPLEVEL->set_title('Karta položky faktury');
    $MyMoney{'MainCfg'}->window_open("KartaPolozkyFaktury",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    if($retok) {
        return(@Polozky);
    };
    return();
};

sub toplevel_hide    { shift->get_toplevel->hide    }
sub toplevel_close   { shift->get_toplevel->close   }
sub toplevel_destroy { shift->get_toplevel->destroy }

sub on_button_close_clicked {
    $MyMoney{'MainCfg'}->window_close("KartaPolozkyFaktury",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_KartaPolozkyFaktury_unrealize {
    $MyMoney{'MainCfg'}->window_close("KartaPolozkyFaktury",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {   
    $MyMoney{'MainCfg'}->window_close("KartaPolozkyFaktury",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    $retok=1;
    $KartaPolozkyFaktury->ReadFromUI($MyUI->FORM);
    $KartaPolozkyFaktury->set('zaklad',$ZAKLAD);
    $KartaPolozkyFaktury->set('dph',$DPH);
    $KartaPolozkyFaktury->set('mjvcdph',$MJVCDPH);
    $KartaPolozkyFaktury->set('celkemzaklad',$CELKEMZAKLAD);
    $KartaPolozkyFaktury->set('celkemdph',$CELKEMDPH);
    $KartaPolozkyFaktury->set('celkemvcdph',$CELKEMVCDPH);

    my $pocetpolozek=@Polozky;
    if((!$polozka) || ($copy)) {
        $pocetpolozek++;
    };
    my @retpol=();
    my $poradi=1;
    for(my $i=0;$i<$pocetpolozek;$i++) {
        if($poradi eq $KartaPolozkyFaktury->get('poradi')) {
            push(@retpol,$KartaPolozkyFaktury);
            $poradi++;
        };
        if($Polozky[$i]) {
            if(($polozka-1) ne $i) {
                push(@retpol,$Polozky[$i]);
                $retpol[$#retpol]->set('poradi',$poradi);
                $poradi++;
            };
        };
    };
    @Polozky=@retpol;
    Gtk2->main_quit;
};

sub on_button_stredisko_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'stredisko'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VFPol_last_stredisko');
    };
    if($Seznam->run('strediska',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$select_row])) {
        my $tbl=new Table('r_SzStred',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'stredisko'}->set_text($tbl->get('zkrat'));
                $MyMoney{'MainCfg'}->set('VFPol_last_stredisko',$tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'stredisko'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_cinnost_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'cinnost'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VFPol_last_cinnost');
    };
    if($Seznam->run('cinnosti',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$select_row])) {
        my $tbl=new Table('r_SzCinn',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'cinnost'}->set_text($tbl->get('zkrat'));
                $MyMoney{'MainCfg'}->set('VFPol_last_cinnost',$tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'cinnost'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_zakazka_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'zakazka'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VFPol_last_zakazka');
    };
    if($Seznam->run('zakazky',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$select_row])) {
        my $tbl=new Table('r_Zakazky',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'zakazka'}->set_text($tbl->get('zkrat'));
                $MyMoney{'MainCfg'}->set('VFPol_last_zakazka',$tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'zakazka'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_predkontace_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $where="typ='0'";
    if($MyMoney{'RokData'}->get('typ_ucetnictvi') eq 'J') {
        $where="typ='P'";
    };
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'predkontace'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VFPol_last_predkontace');
    };
    if($Seznam->run('predkontace_'.$MyMoney{'RokData'}->get('typ_ucetnictvi'),"cfg"=>[%MyMoney],"ok_butt"=>1,"where"=>$where,"selected_rows_by"=>"zkrat",selected_rows=>[$select_row])) {
        my $tbl=new Table('r_UcPrKont_'.$MyMoney{'RokData'}->get('typ_ucetnictvi'),%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'predkontace'}->set_text($tbl->get('zkrat'));
                $MyMoney{'MainCfg'}->set('VFPol_last_predkontace',$tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'predkontace'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_cleneni_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'cleneni'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('VFPol_last_cleneni');
    };
    if($Seznam->run('cleneni',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat",selected_rows=>[$select_row])) {
        my $tbl=new Table('r_UcClnDPH',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'cleneni'}->set_text($tbl->get('zkrat'));
                $MyMoney{'MainCfg'}->set('VFPol_last_cleneni',$tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'cleneni'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_zaruka_changed {
    if(($MyUI->FORM->{'zaruka'}->get_history eq 0) || ($MyUI->FORM->{'zaruka'}->get_history eq 4)) {
        $MyUI->FORM->{'zaruka_n'}->set_sensitive(0);
    } else {
        $MyUI->FORM->{'zaruka_n'}->set_sensitive(1);
    };
};

sub on_typceny_changed {
    if(!$changes_dissabled) {
        if($MyUI->FORM->{'typceny'}->get_history eq 0) {
            $MyUI->FORM->{'sazbadph'}->set_history(0);
            $MyUI->FORM->{'sazbadph'}->set_sensitive(0);
        } else {
            $MyUI->FORM->{'sazbadph'}->set_sensitive(1);
            if(($MyUI->FORM->{'typceny'}->get_history eq 1) || ($MyUI->FORM->{'typceny'}->get_history eq 2)) {
                $MyUI->FORM->{'item242'}->hide;
                if($MyUI->FORM->{'sazbadph'}->get_history eq 0) {
                    $MyUI->FORM->{'sazbadph'}->set_history(1);
                };
            } else {
                $MyUI->FORM->{'item242'}->show;
            };
        };
        $MyUI->on_cenamj_changed;
        $MyMoney{'MainCfg'}->set('VFPol_last_typceny',$MyUI->FORM->{'typceny'}->get_history);
    };
};

sub on_sazbadph_changed {
    $MyUI->on_cenamj_changed;
    $MyMoney{'MainCfg'}->set('VFPol_last_sazbadph',$MyUI->FORM->{'sazbadph'}->get_history);
};

sub on_sleva_changed {
    $MyUI->on_cenamj_changed;
};

sub on_pocetmj_changed {
    $MyUI->on_cenamj_changed;
};

sub on_cenamj_changed {
    my $zaklad;
    my $dph;
    my $sazbadph=$SazbyDPH[$MyUI->FORM->{'sazbadph'}->get_history];

    if($MyUI->FORM->{'typceny'}->get_history eq 0) {
        $zaklad=$MyUI->FORM->{'cenamj'}->get_value;
    };
    if($MyUI->FORM->{'typceny'}->get_history eq 1) {
        $zaklad=($MyUI->FORM->{'cenamj'}->get_value/(100+$sazbadph))*100;
    };
    if($MyUI->FORM->{'typceny'}->get_history eq 2) {
        $zaklad=($MyUI->FORM->{'cenamj'}->get_value/$sazbadph)*100;
    };
    if($MyUI->FORM->{'typceny'}->get_history eq 3) {
        $zaklad=$MyUI->FORM->{'cenamj'}->get_value;
    };
    
    $zaklad-=($zaklad/100)*$MyUI->FORM->{'sleva'}->get_value;
    $dph=($zaklad/100)*$sazbadph;
    
    $ZAKLAD=$zaklad;
    $MyUI->FORM->{'l_mjzaklad'}->set_label(sprintf("%01.4f",$ZAKLAD));
    $DPH=$dph;
    $MyUI->FORM->{'l_mjdph'}->set_label(sprintf("%01.4f",$DPH));
    $MJVCDPH=$zaklad+$dph;
    $MyUI->FORM->{'l_mjvcdph'}->set_label(sprintf("%01.4f",$MJVCDPH));

    $CELKEMZAKLAD=$zaklad*$MyUI->FORM->{'pocetmj'}->get_value;
    $MyUI->FORM->{'l_celkemzaklad'}->set_label(sprintf("%01.2f",$CELKEMZAKLAD));
    $CELKEMDPH=$dph*$MyUI->FORM->{'pocetmj'}->get_value;
    $MyUI->FORM->{'l_celkemdph'}->set_label(sprintf("%01.2f",$CELKEMDPH));
    $CELKEMVCDPH=($zaklad+$dph)*$MyUI->FORM->{'pocetmj'}->get_value;
    $MyUI->FORM->{'l_celkemvcdph'}->set_label(sprintf("%01.2f",$CELKEMVCDPH));
};

1;
